/***********************************************************************************************************************************
Time Management
***********************************************************************************************************************************/
#include "stdio.h"
#include "sys/time.h"

#include "common/time.h"

/***********************************************************************************************************************************
Constants describing number of sub-units in an interval
***********************************************************************************************************************************/
#define MSEC_PER_USEC                                               ((TimeMSec)1000)

/***********************************************************************************************************************************
Epoch time in milliseconds
***********************************************************************************************************************************/
TimeMSec
timeMSec()
{
    struct timeval currentTime;
    gettimeofday(&currentTime, NULL);
    return ((TimeMSec)currentTime.tv_sec * MSEC_PER_SEC) + (TimeMSec)currentTime.tv_usec / MSEC_PER_USEC;
}

/***********************************************************************************************************************************
Sleep for specified milliseconds
***********************************************************************************************************************************/
void
sleepMSec(TimeMSec sleepMSec)
{
    struct timeval delay;
    delay.tv_sec = (__time_t)(sleepMSec / MSEC_PER_SEC);
    delay.tv_usec = (__time_t)(sleepMSec % MSEC_PER_SEC * 1000);
    select(0, NULL, NULL, NULL, &delay);
}
